//===========================================================
//  Filename: MyExp.h
//      3D studio MAX exporter plugin
//      Copyright 2003
//      Created by Roman E. Marchenko, vortex@library.ntu-kpi.kiev.ua
//      $Id$
//===========================================================

#ifndef _MY_3DSMAX_PLUGIN_H_
#define _MY_3DSMAX_PLUGIN_H_

#include <windows.h>
#include <Max.h>
#include <fstream.h>
#include <stdmat.h>
#include <string>
#include "ExpDefines.h"
#include "imdfile.h"

#define MYEXP_CLASS_ID Class_ID(0x280d4a49, 0x4abe3694)

#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "core.lib")
#pragma comment(lib, "maxutil.lib")
#pragma comment(lib, "geom.lib")
#pragma comment(lib, "mesh.lib")

typedef std::string remString;

// Global variables

class MyExp : public SceneExport  
{
public:
// All this functions must be implemented to proper plugin loading to 3ds max
	int				ExtCount()			{ return 1; }
	const TCHAR*	Ext(int i)			{ if (i == 0) return _T("IMD"); else return _T(""); }
	const TCHAR*	LongDesc()			{ return _T("My export first plugin"); }
	const TCHAR*	ShortDesc()			{ return _T("My exporter"); }
	const TCHAR*	AuthorName()		{ return _T("Roman Marchenko"); }
	const TCHAR*	CopyrightMessage()	{ return _T("Copyleft (C) 2003"); }
	const TCHAR*	OtherMessage1()		{ return _T(""); }
	const TCHAR*	OtherMessage2()		{ return _T(""); }
	unsigned int	Version()			{ return 100; }
	void			ShowAbout(HWND hWnd){ MessageBox(hWnd, "First exporter plugin", "About", MB_OK); }
	BOOL			SupportsOptions(int ext, DWORD options);

	// This function do export
	int				DoExport(const TCHAR *name, ExpInterface *ei,
							 Interface *i, BOOL suppressPromts = FALSE, DWORD options = 0);
	MyExp();
	virtual ~MyExp();
};

class SceneSaver: public ITreeEnumProc
{
public:
	// SubExporters
	int ExportMaterial(INode *node);
	void ExportGVTX(TriObject *TObj,int mat_index,Matrix3 tm);
	void ExportHelper(INode* node);
	void ExportGBND(INode* node);
	void ExportGELP(INode* node);

	// Main functions
	int callback(INode *node);
	void ProcNode(INode *node);
};

// Standalone functions
TriObject	*GetTriObjFromNode(INode *node, int &deleteIt);
remString	ExtractFileName(remString filename);

#endif