#include "imdfile.h"

//---------------------------------------------------------------------------
TIMDFile::TIMDFile()
{
  gmat=new TObjectList();
  gvtx=new TObjectList();
  gref=new TGREF();
  gref->refs=new TObjectList();
  gbnd=new TGBND();
  gbnd->spheres=new TObjectList();
  gelp=0;
//	gmat.Init();
//	gvtx.Init();
//  gmat=0;
//  gvtx=0;
  gvtx_count=0;
  gmat_count=0;
//  gref.ref_count=0;
  buf=0;
  size=0;
  gelp=0;
}
//---------------------------------------------------------------------------
TIMDFile::~TIMDFile()
{
	delete gmat;
	delete gvtx;
	delete gref;
	delete gbnd;
	if(gelp!=0)delete gelp;
}
//---------------------------------------------------------------------------
int WriteStr(FILE* F,char* str)
{
	char zerro=(char)0;
	int size=strlen(str);
	size=((int)size/4)*4+4;
	fwrite(&size,4,1,F);
	fwrite(str,strlen(str),1,F);
	for(int j=0;j<size-strlen(str);j++)
		fwrite(&zerro,1,1,F); //  ...
	return size+4;
}
//---------------------------------------------------------------------------
int TIMDFile::Save(char* file_name)
{
  FILE* F=fopen(file_name,"wb");
  int magic=100,zerro=0;
  float flt=1.0;
  int tmp;
  int size;

  char sign[5];
  char block_sign[5];
  unsigned int block_size;
  int tmpsize;
  if(!F)return 1;
  fwrite("LIBF",4,1,F);
  fwrite("    ",4,1,F); //    ...  
  fwrite("IDFMGNFO",8,1,F);
  fwrite("    ",4,1,F); //   GREF
  fwrite(&magic,4,1,F);
  for(int i=0;i<6;i++)fwrite(&zerro,4,1,F);
  fwrite(&flt,4,1,F);
  tmp=gvtx_count;
  fwrite(&tmp,4,1,F);
  tmp=gmat_count;
  fwrite(&tmp,4,1,F);
  TGMAT* material=(TGMAT*)gmat->First();
  for(int i=0;i<gmat->Count();i++)
  {
	  block_size=12;
	  fwrite("GMAT",4,1,F);
	  long pos=ftell(F);
	  fwrite("    ",4,1,F); //   ;
	  fwrite(&magic,4,1,F);
	  block_size+=WriteStr(F,material->material_name);
	  fwrite(&material->koeff,sizeof(material->koeff),1,F);
	  block_size+=sizeof(material->koeff);
	  size=material->texture_count;
	  fwrite(&size,4,1,F);
	  block_size+=4;
	  for(int j=0;j<material->texture_count;j++)
	  {
		  fwrite(&material->textures[j].type,4,1,F);
		  block_size+=4;
		  block_size+=WriteStr(F,material->textures[j].file_name);
		  fwrite(&material->textures[j].koeff,4,1,F);
		  block_size+=4;
	  }
	  fseek(F,pos,SEEK_SET);
	  fwrite(&block_size,4,1,F);
	  fseek(F,0,SEEK_END);
	  material=(TGMAT*)gmat->Next();
  }
  TGVTX* vertex=(TGVTX*)gvtx->First();
  for(int i=0;i<gvtx->Count();i++)
  {
	  block_size=28+vertex->point_count*32+vertex->polygon_count*18;
	  fwrite("GVTX",4,1,F);
	  fwrite(&block_size,4,1,F);
	  fwrite(&magic,4,1,F);
	  fwrite(&vertex->material_index,4,1,F);
	  flt=1495.559; //     ?! :(
	  fwrite(&flt,4,1,F);
	  size=vertex->point_count;
	  fwrite(&size,4,1,F);
	  size=vertex->polygon_count;
	  fwrite(&size,4,1,F);
	  for(int j=0;j<vertex->point_count;j++)
	  {
		  fwrite(&vertex->points[j].x,4,1,F);
		  fwrite(&vertex->points[j].y,4,1,F);
		  fwrite(&vertex->points[j].z,4,1,F);
		  fwrite(&vertex->points[j].a,4,1,F);
		  fwrite(&vertex->points[j].b,4,1,F);
	  }
	  for(int j=0;j<vertex->polygon_count;j++)
	  {
		  fwrite(&vertex->polygons[j].a,2,1,F);
		  fwrite(&vertex->polygons[j].b,2,1,F);
		  fwrite(&vertex->polygons[j].c,2,1,F);
	  }
	  for(int j=0;j<vertex->point_count;j++)
	  {
		  fwrite(&vertex->vnormals[j].x,4,1,F);
		  fwrite(&vertex->vnormals[j].y,4,1,F);
		  fwrite(&vertex->vnormals[j].z,4,1,F);
	  }
	  for(int j=0;j<vertex->polygon_count;j++)
	  {
		  fwrite(&vertex->fnormals[j].x,4,1,F);
		  fwrite(&vertex->fnormals[j].y,4,1,F);
		  fwrite(&vertex->fnormals[j].z,4,1,F);
	  }
	  vertex=(TGVTX*)gvtx->Next();
  }
  fwrite("GBND",4,1,F);
  size=32+gbnd->spheres->Count()*16;
  fwrite(&size,4,1,F);
  fwrite(&magic,4,1,F);
  fwrite(&gbnd->mainsphera->x,4,1,F);
  fwrite(&gbnd->mainsphera->y,4,1,F);
  fwrite(&gbnd->mainsphera->z,4,1,F);
  fwrite(&gbnd->mainsphera->r,4,1,F);
  fwrite(&gbnd->spheres->count,4,1,F);
  TSphera* s=(TSphera*)gbnd->spheres->First();
  for(int i=0;i<gbnd->spheres->Count();i++)
  {
	  fwrite(&s->x,4,1,F);
	  fwrite(&s->y,4,1,F);
	  fwrite(&s->z,4,1,F);
	  fwrite(&s->r,4,1,F);
	  s=(TSphera*)gbnd->spheres->Next();
  }
  if(gelp!=0)
  {
	  fwrite("GELP",4,1,F);
	  tmp=36;
	  fwrite(&tmp,4,1,F);
	  fwrite(&magic,4,1,F);
	  fwrite(&gelp->x,4,1,F);
	  fwrite(&gelp->y,4,1,F);
	  fwrite(&gelp->z,4,1,F);
	  fwrite(&gelp->dx,4,1,F);
	  fwrite(&gelp->dy,4,1,F);
	  fwrite(&gelp->dz,4,1,F);
  }
  int pos=ftell(F)-12; //   GREF
  fwrite("GREF",4,1,F);
  size=16;
  fwrite(&size,4,1,F);
  fwrite(&magic,4,1,F);
  fwrite(&gref->refs->count,4,1,F);
  TREFPoint* points=(TREFPoint*)gref->refs->First();
  for(int i=0;i<gref->refs->count;i++)
  {
	  size+=WriteStr(F,points->name);
	  for(int j=0;j<4;j++)
		  for(int ij=0;ij<4;ij++)
			  fwrite(&points->matrix[j][ij],4,1,F);
	  size+=16*4;
	  fwrite(&points->x,4,1,F);
	  fwrite(&points->y,4,1,F);
	  fwrite(&points->z,4,1,F);
	  tmp=0xFFDCAAF0;
	  flt=0;
	  fwrite(&tmp,4,1,F);
	  size+=16;
	  points=(TREFPoint*)gref->refs->Next();
  }
  long file_size=ftell(F);
  fseek(F,pos+16,SEEK_SET);
  fwrite(&size,4,1,F);
  fseek(F,4,SEEK_SET);
  fwrite(&file_size,4,1,F);
  fseek(F,16,SEEK_SET);
  fwrite(&pos,4,1,F);
  fclose(F);
  return 0;
}
//---------------------------------------------------------------------------
TObjectNode::TObjectNode(TBaseObject* a)
{
	data=a;
	next=0;
	prev=0;
	index=-1;
}
//---------------------------------------------------------------------------
TObjectNode::~TObjectNode()
{
	if(data!=0)delete data;
}
//---------------------------------------------------------------------------
TObjectNode* TObjectNode::Next()
{
	return next;
}
//---------------------------------------------------------------------------
TObjectNode* TObjectNode::Prev()
{
	return prev;
}
//---------------------------------------------------------------------------
TBaseObject* TObjectNode::Data()
{
	return data;
}
//---------------------------------------------------------------------------
TObjectList::TObjectList()
{
	first=win=new TObjectNode(0);
	count=0;
}
//---------------------------------------------------------------------------
TObjectList::~TObjectList()
{
	win=first;
	while(win!=0)
	{
		first=win->Next();
		delete win;
		win=first;
	}
}
//---------------------------------------------------------------------------
void TObjectList::Add(TBaseObject* a)
{
	while(win->Next()!=0)win=win->Next();
	win->next=new TObjectNode(a);
	win->next->index=win->index+1;
	win->next->prev=win;
	win=win->next;
	count++;
}
//---------------------------------------------------------------------------
TBaseObject* TObjectList::Next()
{
	if(win->next!=0)
		win=win->next;
	return win->Data();
}
//---------------------------------------------------------------------------
TBaseObject* TObjectList::Prev()
{
	if(win->prev!=first)
		win=win->prev;
	return win->Data();
}
//---------------------------------------------------------------------------
TBaseObject* TObjectList::First()
{
	if(first->next!=0)
		win=first->next;
	return win->Data();
}
//---------------------------------------------------------------------------
int TObjectList::Count()
{
	return count;
}
//---------------------------------------------------------------------------
TGVTX::TGVTX(unsigned int apoint_count,unsigned int apolygon_count,
			 unsigned int amaterial_index):TBlockObject("GVTX")
{
	point_count=apoint_count;
	polygon_count=apolygon_count;
	material_index=amaterial_index;
	points=new MPoint[point_count];
	polygons= new MPolygon[polygon_count];
	vnormals=new TVector[point_count];
	fnormals=new TVector[polygon_count];
}
//---------------------------------------------------------------------------
TGVTX::~TGVTX()
{
	delete[] points;
	delete[] polygons;
	delete[] vnormals;
	delete[] fnormals;
}
//---------------------------------------------------------------------------
TGMAT::TGMAT(char* amaterial_name):TBlockObject("GMAT")
{
	material_name=strdup(amaterial_name);
}
//---------------------------------------------------------------------------
TGMAT::~TGMAT()
{
	delete[]material_name;
}
//---------------------------------------------------------------------------
TREFPoint::TREFPoint(char* aname):TBaseObject()
{
	name=strdup(aname);
}
//---------------------------------------------------------------------------
TREFPoint::~TREFPoint()
{
	delete[]name;
}
//---------------------------------------------------------------------------
TGREF::TGREF():TBlockObject("GREF")
{
	refs=new TObjectList();
}
//---------------------------------------------------------------------------
TGREF::~TGREF()
{
	delete refs;
}
//---------------------------------------------------------------------------
TSphera::TSphera(float ax,float ay,float az,float ar):TBaseObject()
{
	x=ax;
	y=ay;
	z=az;
	r=ar;
}
//---------------------------------------------------------------------------
TSphera::~TSphera()
{
}
//---------------------------------------------------------------------------
TGBND::TGBND():TBlockObject("GBND")
{
	mainsphera=new TSphera(0,0,0,0);
	spheres=new TObjectList();
}
//---------------------------------------------------------------------------
TGBND::~TGBND()
{
	delete mainsphera;
	delete spheres;
}
//---------------------------------------------------------------------------
TGELP::TGELP(float ax,float ay,float az,float adx,float ady,float adz):TBlockObject("GELP")
{
	x=ax;
	y=ay;
	z=az;
	dx=adx;
	dy=ady;
	dz=adz;
}
//---------------------------------------------------------------------------
TGELP::~TGELP()
{
}
//---------------------------------------------------------------------------
