
/**********************************************************************
 *<
	FILE: objimp.h

	DESCRIPTION:  Wavefront .OBJ file import module header file

	CREATED BY: Don Brittain & Tom Hudson

	HISTORY: created 30 December 1994

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/
#include "imdfile.h"
#include <stdmat.h>

#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "core.lib")
#pragma comment(lib, "maxutil.lib")
#pragma comment(lib, "geom.lib")
#pragma comment(lib, "mesh.lib")

class OBJImport : public SceneImport {
public:
	BOOL fnew_scene;
	BOOL fmaterial;
	BOOL frefpoint;
	BOOL fgbnd;
	BOOL fgelp;
					OBJImport();
					~OBJImport();
	int				ExtCount();					// Number of extensions supported
	const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
	const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
	const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
	const TCHAR *	AuthorName();				// ASCII Author name
	const TCHAR *	CopyrightMessage();			// ASCII Copyright message
	const TCHAR *	OtherMessage1();			// Other message #1
	const TCHAR *	OtherMessage2();			// Other message #2
	unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
	void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box
	int				DoImport(const TCHAR *name,ImpInterface *i,Interface *gi, BOOL suppressPrompts=FALSE);	// Import file
	void ImportGMAT(TIMDFile* imd,StdMat** mtl,Interface *gi);
	void ImportGVTX(TIMDFile* imd,StdMat** mtl,ImpInterface *i);
	void ImportGREF(TIMDFile* imd,Interface *gi,ImpInterface *i);
	void ImportGBND(TIMDFile* imd,Interface *gi,ImpInterface *i);
	void ImportGELP(TIMDFile* imd,Interface *gi,ImpInterface *i);
	};
